Halide 22.0.0 Halide compiler and libraries

Loading...
Searching...
No Matches
Classes | Public Member Functions | Public Attributes | Static Public Attributes | List of all members
Halide::Internal::IRMatcher::NotOp< A > Struct Template Reference

`#include <IRMatch.h>`

## Classes
struct | pattern_tag

## Public Member Functions
template<uint32_t bound>
HALIDE_ALWAYS_INLINE bool | match (const BaseExprNode &e, MatcherState &state) const noexcept
template<uint32_t bound, typename A2 >
HALIDE_ALWAYS_INLINE bool | match (const NotOp< A2 > &op, MatcherState &state) const noexcept
HALIDE_ALWAYS_INLINE Expr | make (MatcherState &state, halide_type_t type_hint) const
template<typename A1 = A>
HALIDE_ALWAYS_INLINE void | make_folded_const (halide_scalar_value_t &val, halide_type_t &ty, MatcherState &state) const noexcept

## Public Attributes
A | a

## Static Public Attributes
static constexpr uint32_t | binds = bindings<A>::mask
static constexpr IRNodeType | min_node_type = IRNodeType::Not
static constexpr IRNodeType | max_node_type = IRNodeType::Not
static constexpr bool | canonical = A::canonical
static constexpr bool | foldable = A::foldable

## Detailed Description

template<typename A>
struct Halide::Internal::IRMatcher::NotOp< A >

Definition at line 1613 of file IRMatch.h.

## Member Function Documentation

## ◆ match() [1/2]

template<typename A >
template<uint32_t bound>

HALIDE_ALWAYS_INLINE bool Halide::Internal::IRMatcher::NotOp< A >::match | ( | const BaseExprNode & | e,
|  | MatcherState & | state
| ) |  | const
| inline noexcept

Definition at line 1624 of file IRMatch.h.

References Halide::Internal::Not::a, Halide::Internal::IRMatcher::NotOp< A >::a, Halide::Internal::IRMatcher::cast(), Halide::Expr::get(), and Halide::Internal::Not.

## ◆ match() [2/2]

template<typename A >
template<uint32_t bound, typename A2 >

HALIDE_ALWAYS_INLINE bool Halide::Internal::IRMatcher::NotOp< A >::match | ( | const NotOp< A2 > & | op,
|  | MatcherState & | state
| ) |  | const
| inline noexcept

Definition at line 1633 of file IRMatch.h.

References Halide::Internal::IRMatcher::NotOp< A >::a, Halide::Internal::IRMatcher::cast(), and Halide::Internal::IRMatcher::unwrap().

## ◆ make()

template<typename A >

HALIDE_ALWAYS_INLINE Expr Halide::Internal::IRMatcher::NotOp< A >::make | ( | MatcherState & | state,
|  | halide_type_t | type_hint
| ) |  | const
| inline

Definition at line 1638 of file IRMatch.h.

References Halide::Internal::IRMatcher::NotOp< A >::a, Halide::Internal::IRMatcher::cast(), and Halide::Internal::Not::make().

## ◆ make_folded_const()

template<typename A >
template<typename A1 = A>

HALIDE_ALWAYS_INLINE void Halide::Internal::IRMatcher::NotOp< A >::make_folded_const | ( | halide_scalar_value_t & | val,
|  | halide_type_t & | ty,
|  | MatcherState & | state
| ) |  | const
| inline noexcept

Definition at line 1645 of file IRMatch.h.

References Halide::Internal::IRMatcher::NotOp< A >::a, and Halide::Internal::IRMatcher::cast().

## Member Data Documentation

## ◆ a

template<typename A >

A Halide::Internal::IRMatcher::NotOp< A >::a

Definition at line 1615 of file IRMatch.h.

Referenced by Halide::Internal::IRMatcher::NotOp< A >::make(), Halide::Internal::IRMatcher::NotOp< A >::make_folded_const(), Halide::Internal::IRMatcher::NotOp< A >::match(), Halide::Internal::IRMatcher::NotOp< A >::match(), and Halide::Internal::IRMatcher::operator<<().

## ◆ binds

template<typename A >

constexpr uint32_t Halide::Internal::IRMatcher::NotOp< A >::binds = bindings<A>::mask
| static constexpr

Definition at line 1617 of file IRMatch.h.

## ◆ min_node_type

template<typename A >

constexpr IRNodeType Halide::Internal::IRMatcher::NotOp< A >::min_node_type = IRNodeType::Not
| static constexpr

Definition at line 1619 of file IRMatch.h.

## ◆ max_node_type

template<typename A >

constexpr IRNodeType Halide::Internal::IRMatcher::NotOp< A >::max_node_type = IRNodeType::Not
| static constexpr

Definition at line 1620 of file IRMatch.h.

## ◆ canonical

template<typename A >

constexpr bool Halide::Internal::IRMatcher::NotOp< A >::canonical = A::canonical
| static constexpr

Definition at line 1621 of file IRMatch.h.

## ◆ foldable

template<typename A >

constexpr bool Halide::Internal::IRMatcher::NotOp< A >::foldable = A::foldable
| static constexpr

Definition at line 1642 of file IRMatch.h.

The documentation for this struct was generated from the following file:

- src/IRMatch.h